Issue 96841

Summary: Build breaks in pyuno: pyconfig.h not found
Product: udk Reporter: christianlins <christian.lins>
Component: codeAssignee: joergbudi
Status: CLOSED FIXED QA Contact: issues@udk <issues>
Severity: Trivial    
Priority: P2 CC: christian.lins, issues, jeongkyu.kim, joergbudi, nesshof
Version: DEV300m36   
Target Milestone: OOo 3.1   
Hardware: PC   
OS: Linux, all   
Issue Type: DEFECT Latest Confirmation in: ---
Developer Difficulty: ---

Description christianlins 2008-12-03 10:43:22 UTC
On Ubuntu Intrepid with gcc-4.3.2 the build breaks with:

"Making: ../../unxlngi6.pro/slo/pyuno_module.obj
g++  -fmessage-length=0 -c -O0  
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/python -I.
 -I../../unxlngi6.pro/inc/pyuno -I../inc -I../../inc/pch -I../../inc
-I../../unx/inc -I../../unxlngi6.pro/inc -I.
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/stl
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/external
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solenv/unxlngi6/inc
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solenv/inc
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/res
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/stl
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solenv/inc/Xp31
-I/usr/lib/jvm/java-6-sun/include -I/usr/lib/jvm/java-6-sun/include/linux
-I/usr/lib/jvm/java-6-sun/include/native_threads/include -I/usr/include 
-I/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/offuh
-I. -I../../res -I. -pipe -mtune=pentiumpro -fvisibility-inlines-hidden -Wall
-Wextra -Wendif-labels -Wshadow -Wno-ctor-dtor-privacy     -Wno-non-virtual-dtor
  -fpic -DLINUX -DUNX -DVCL -DGCC -DC341 -DINTEL -DCVER=C341 -DNPTL -DGLIBC=2
-DX86 -D_PTHREADS -D_REENTRANT -DNEW_SOLAR -D_USE_NAMESPACE=1
-DSTLPORT_VERSION=400 -DHAVE_GCC_VISIBILITY_FEATURE -D__DMAKE -DUNIX
-DCPPU_ENV=gcc3 -DGXX_INCLUDE_PATH=/usr/include/c++/4.3 -DSUPD=300 -DPRODUCT
-DNDEBUG -DPRODUCT_FULL -DOSL_DEBUG_LEVEL=0 -DCUI -DSOLAR_JAVA   -DSHAREDLIB
-D_DLL_   -fexceptions -fno-enforce-eh-specs -DEXCEPTIONS_ON  -o
../../unxlngi6.pro/slo/pyuno_module.o
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx 
In file included from ../../inc/pyuno/pyuno.hxx:13,
                 from
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_impl.hxx:33,
                 from
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx:31:
/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/python/Python.h:8:22:
error: pyconfig.h: No such file or directory
/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/python/Python.h:21:2:
error: #error "limits.h is required by std C -- why isn't HAVE_LIMITS_H defined?"
In file included from
/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/python/Python.h:48,
                 from ../../inc/pyuno/pyuno.hxx:13,
                 from
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_impl.hxx:33,
                 from
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx:31:
/media/sdb1/buildbot/slavedir/ubuntu/workdir/solver/300/unxlngi6.pro/inc/python/pyport.h:535:2:
error: #error "could not set LONG_MAX in pyport.h"
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx:
In function >>PyObject*<unnamed>::setCurrentContext(PyObject*, PyObject*)<<:
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx:665:
Warnung: Klammern um && innerhalb von || empfohlen
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx:
In function >>void initpyuno()<<:
/media/sdb1/buildbot/slavedir/ubuntu/workdir/pyuno/source/module/pyuno_module.cxx:718:
Fehler: >>PyEval_InitThreads<< wurde in diesem G?ltigkeitsbereich nicht definiert
dmake:  Error code 1, while making '../../unxlngi6.pro/slo/pyuno_module.obj'
dmake:  Error code 255, while making 'do_it_noopt'
"

Can probably be work-arounded using --with-system-python configure switch.
Comment 1 kay.ramme 2008-12-05 14:28:34 UTC
Stumbled over the same - and switched to --with-system-python - going to take a
look ..
Comment 2 kay.ramme 2008-12-16 08:57:23 UTC
For some reasons the "pyconfig.h" header does not get delivered ...
Comment 3 kay.ramme 2008-12-16 09:07:25 UTC
Seems that python just does not get through ...
Comment 4 kay.ramme 2008-12-16 12:00:08 UTC
On my system "python" dies as follows, while the build system does not detect
the error ...


PYTHONPATH=/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/python-inst/lib/python2.3
 LD_LIBRARY_PATH=/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4:.:/usr/local/kr/OOO300_m9/solenv/unxlngi6.pro/lib:/usr/lib/jvm/java-1.5.0-sun/jre/lib/i386:/usr/lib/jvm/java-1.5.0-sun/jre/lib/i386/xawt:/usr/lib/jvm/java-1.5.0-sun/jre/lib/i386/client:/usr/lib/jvm/java-1.5.0-sun/jre/lib/i386/native_threads:../lib:/usr/local/kr/OOO300_m9/solver/300/unxlngi6.pro/lib:.:/usr/local/kr/OOO300_m9/solenv/unxlngx6.pro/lib:/usr/lib/jvm/java-1.5.0-sun/jre/lib/amd64:/usr/lib/jvm/java-1.5.0-sun/jre/lib/amd64/xawt:/usr/lib/jvm/java-1.5.0-sun/jre/lib/amd64/server:/usr/lib/jvm/java-1.5.0-sun/jre/lib/amd64/native_threads:../lib64:/usr/local/kr/OOO300_m9/solver/300/unxlngx6.pro/lib: \
		 ./python -Wi -tt
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/python-inst/lib/python2.3/compileall.py
\
		-d
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/python-inst/lib/python2.3
-f \
		-x 'badsyntax|site-packages'
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/python-inst/lib/python2.3
*** buffer overflow detected ***: ./python terminated
======= Backtrace: =========
/lib/tls/i686/cmov/libc.so.6(__fortify_fail+0x48)[0x557d0558]
/lib/tls/i686/cmov/libc.so.6[0x557ce680]
/lib/tls/i686/cmov/libc.so.6[0x557cede8]
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/libpython2.3.so.1.0(PySys_SetArgv+0x1d6)[0x55627ad6]
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/libpython2.3.so.1.0(Py_Main+0x3a3)[0x5562be13]
./python(main+0x32)[0x8048642]
/lib/tls/i686/cmov/libc.so.6(__libc_start_main+0xe5)[0x556ec685]
./python[0x8048571]
======= Memory map: ========
08048000-08049000 r-xp 00000000 fe:00 8180145                           
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/python
08049000-0804a000 r--p 00000000 fe:00 8180145                           
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/python
0804a000-0804b000 rw-p 00001000 fe:00 8180145                           
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/python
08d4f000-08dc1000 rw-p 08d4f000 00:00 0                                  [heap]
55555000-5556f000 r-xp 00000000 09:00 1011760                           
/lib/ld-2.8.90.so
5556f000-55570000 r-xp 5556f000 00:00 0                                  [vdso]
55570000-55571000 r--p 0001a000 09:00 1011760                           
/lib/ld-2.8.90.so
55571000-55572000 rw-p 0001b000 09:00 1011760                           
/lib/ld-2.8.90.so
55572000-55575000 rw-p 55572000 00:00 0 
55575000-55659000 r-xp 00000000 fe:00 8179963                           
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/libpython2.3.so.1.0
55659000-5565a000 r--p 000e4000 fe:00 8179963                           
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/libpython2.3.so.1.0
5565a000-55679000 rw-p 000e5000 fe:00 8179963                           
/usr/local/kr/OOO300_m9/python/unxlngi6.pro/misc/build/Python-2.3.4/libpython2.3.so.1.0
55679000-5567c000 rw-p 55679000 00:00 0 
5567c000-55686000 r-xp 00000000 fe:00 8131078                           
/usr/local/kr/OOO300_m9/solver/300/unxlngi6.pro/lib/libgcc_s.so.1
55686000-55687000 rw-p 0000a000 fe:00 8131078                           
/usr/local/kr/OOO300_m9/solver/300/unxlngi6.pro/lib/libgcc_s.so.1
5568f000-556a4000 r-xp 00000000 09:00 1022218                           
/lib/tls/i686/cmov/libpthread-2.8.90.so
556a4000-556a5000 r--p 00014000 09:00 1022218                           
/lib/tls/i686/cmov/libpthread-2.8.90.so
556a5000-556a6000 rw-p 00015000 09:00 1022218                           
/lib/tls/i686/cmov/libpthread-2.8.90.so
556a6000-556a8000 rw-p 556a6000 00:00 0 
556a8000-556aa000 r-xp 00000000 09:00 1022207                           
/lib/tls/i686/cmov/libdl-2.8.90.so
556aa000-556ab000 r--p 00001000 09:00 1022207                           
/lib/tls/i686/cmov/libdl-2.8.90.so
556ab000-556ac000 rw-p 00002000 09:00 1022207                           
/lib/tls/i686/cmov/libdl-2.8.90.so
556ac000-556ae000 r-xp 00000000 09:00 1022223                           
/lib/tls/i686/cmov/libutil-2.8.90.so
556ae000-556af000 r--p 00001000 09:00 1022223                           
/lib/tls/i686/cmov/libutil-2.8.90.so
556af000-556b0000 rw-p 00002000 09:00 1022223                           
/lib/tls/i686/cmov/libutil-2.8.90.so
556b0000-556d4000 r-xp 00000000 09:00 1022208                           
/lib/tls/i686/cmov/libm-2.8.90.so
556d4000-556d5000 r--p 00023000 09:00 1022208                           
/lib/tls/i686/cmov/libm-2.8.90.so
556d5000-556d6000 rw-p 00024000 09:00 1022208                           
/lib/tls/i686/cmov/libm-2.8.90.so
556d6000-5582e000 r-xp 00000000 09:00 1022204                           
/lib/tls/i686/cmov/libc-2.8.90.so
5582e000-55830000 r--p 00158000 09:00 1022204                           
/lib/tls/i686/cmov/libc-2.8.90.so
55830000-55831000 rw-p 0015a000 09:00 1022204                           
/lib/tls/i686/cmov/libc-2.8.90.so
55831000-5597b000 rw-p 55831000 00:00 0 
fff23000-fff39000 rw-p 7ffffffe9000 00:00 0                              [stack]
Aborted
make: *** [libinstall] Error 134
Comment 5 kay.ramme 2008-12-16 12:01:37 UTC
Joerg, do you have any clue about this?
Comment 6 kay.ramme 2008-12-16 12:34:24 UTC
Seems that Python 2.3.4 stumbles over -D_FORTIFY_SOURCE=2 , which has been
enabled by default for Ubuntu 8.10 (see
https://wiki.ubuntu.com/CompilerFlags#-D_FORTIFY_SOURCE=2).
Comment 7 kay.ramme 2008-12-16 12:42:25 UTC
Patching the python makefile with

  CPPFLAGS=	-D_FORTIFY_SOURCE=0 ...

is a workaround.

I suggest to upgrade the OOo provided python to 2.4, where this issue seems to
be fixed ...


Comment 8 kay.ramme 2009-01-06 16:15:23 UTC
Changed from P1 to P2 as a workaround is available ..
Comment 9 kay.ramme 2009-01-06 16:21:07 UTC
A while ago someone from RedFlag CH2000 wanted to upgrade the brought python to 2.4 (I contacted Eric 
B. about this), which seems to be already obsolet as 2.5 and 2.6 and 3.0 are available.

AFAIK JBU is still the official python maintainer, so if nobody volunteers I am going assign this issue to 
JBU.

Comment 10 kay.ramme 2009-02-11 14:25:37 UTC
Joerg, now it is yours ... ;-)
Comment 11 joergbudi 2009-02-17 20:22:59 UTC
started work on python26 cws, but this may take a while.

@kr: thx for the effort to look into this ...
Comment 12 Martin Hollmichel 2009-04-22 13:52:48 UTC
is doing now well on ubuntu with the upgrade to 2.6